function general(gatelength,oxidethickness,gatedielectric,substrate,gatevoltage,io)



a = strcmp(gatedielectric,'SiO2');
b = strcmp(gatedielectric,'HfO2');
c = strcmp(gatedielectric,'Al2O3');
d = strcmp(gatedielectric,'HfSiO4');



if a == 1
   oxide = 3.9;
   bf = 1;
elseif b == 1
   oxide = 25;
   bf = 0.54
elseif c == 1
   oxide = 9;
   bf = 0.75;
elseif d == 1
   oxide = 11;
   bf = 0.84;
end

a = strcmp(substrate,'Si');
b = strcmp(substrate,'Ge');
c = strcmp(substrate,'GaAs');

if a == 1
  sub_mob = 1400;
  Ks = 11.9;
  ni = 1.5*10^16;
elseif b == 1
  sub_mob = 3900;
  Ks = 16;
  ni = 2.4*10^19;
elseif c == 1
  sub_mob = 8500;
  Ks = 13.1;
  ni = 1.79*10^12;
end



  W = 800;
  Na = 1*10^21;
  sub_thr = 2*0.0257*log(Na/ni)+(Ks*oxidethickness*10^-9/oxide)*sqrt(((4*1.6*10^16/8.85)/Ks)*0.0257*log(Na/ni))
  efield = gatevoltage/oxidethickness;
  if efield > bf | efield == bf 
        error('Oxide layer breakdown. Electric field is too high!');
  end
  
  if gatevoltage < sub_thr | gatevoltage == sub_thr
        drain_v_linear_single = 0:0.0001:5;
        Id = 0*drain_v_linear_single;
        
        drain_v_sat_single = 0:0.0001:5;
        Id_sat = 0*drain_v_sat_single;
  else
        
        drain_v_linear_single = 0:0.0001:gatevoltage-sub_thr;
        Id = (1000*(((oxide*W*sub_mob*8.85*10^(-14))/(oxidethickness*gatelength*10^(-7))).*((gatevoltage-sub_thr-0.5*drain_v_linear_single).*drain_v_linear_single))).*(1+0.01*drain_v_linear_single);
        
        %saturated region
        drain_v_sat_single = (gatevoltage-sub_thr):0.0001:5;
        n = drain_v_sat_single./drain_v_sat_single;
        Id_sat = (1+0.01*drain_v_sat_single).*((1000*((oxide*W*sub_mob*8.85*10^(-14))/(oxidethickness*gatelength*10^(-7))*((gatevoltage-sub_thr)^2)/2))*n);
  end
 
xydata = [drain_v_linear_single;Id];
str = sprintf('%12g %12g\n', xydata);
rpLibPutString(io,'output.curve(simplot).about.group','Characteristic Plot (Id vs. Vd)',0);
rpLibPutString(io,'output.curve(simplot).about.style','-color blue',0);
rpLibPutString(io,'output.curve(simplot).about.label','Linear region',0);
rpLibPutString(io,'output.curve(simplot).xaxis.label','Drain Voltage',0);
rpLibPutString(io,'output.curve(simplot).xaxis.units','V',0);
rpLibPutString(io,'output.curve(simplot).yaxis.label','Drain Current',0);
rpLibPutString(io,'output.curve(simplot).yaxis.units','mA',0);
rpLibPutString(io,'output.curve(simplot).component.xy',str,0);


xydata_sat = [drain_v_sat_single;Id_sat];
str_sat = sprintf('%12g %12g\n', xydata_sat);
rpLibPutString(io,'output.curve(value1).about.group','Characteristic Plot (Id vs. Vd)',0);
rpLibPutString(io,'output.curve(value1).about.style','-color blue',0);
rpLibPutString(io,'output.curve(value1).about.label','Saturation region',0);
rpLibPutString(io,'output.curve(value1).xaxis.label','Drain Voltage',0);
rpLibPutString(io,'output.curve(value1).xaxis.units','V',0);
rpLibPutString(io,'output.curve(value1).yaxis.label','Drain Current',0);
rpLibPutString(io,'output.curve(value1).yaxis.units','mA',0);
rpLibPutString(io,'output.curve(value1).component.xy',str_sat,0);
