function main(io)

% ----------------------------------------------------------------------
%  MAIN PROGRAM - generated by the Rappture Builder
% ----------------------------------------------------------------------

% open the XML file containing the run parameters
% the file name comes in from the command-line via variable 'infile'
% io = rpLib(infile);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get input values from Rappture
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% get input value for input.integer(gatelength)
gatelength = rpLibGetDouble(io,'input.phase(one).number(gatelength).current');

% get input value for input.integer(oxidethickness)
oxidethickness = rpLibGetDouble(io,'input.phase(one).number(oxidethickness).current');

% get input value for input.choice(gatedielectric)
gatedielectric = rpLibGetString(io,'input.phase(one).choice(gatedielectric).current');

% get input value for input.choice(substrate)
substrate = rpLibGetString(io,'input.phase(one).choice(substrate).current');

% get input value for input.choice(gatevoltage)
gatevoltage = rpLibGetString(io,'input.phase(one).number(gatevoltage).current');
gatevoltage = rpUnitsConvertDbl(gatevoltage,'V');

% get max gate voltage
maxgatevoltage = rpLibGetString(io,'input.phase(one).number(maxgatevoltage).current');
maxgatevoltage = rpUnitsConvertDbl(maxgatevoltage,'V');

% get min gate voltage 
mingatevoltage = rpLibGetString(io,'input.phase(one).number(mingatevoltage).current');
mingatevoltage = rpUnitsConvertDbl(mingatevoltage,'V');

% get step size
step1 = rpLibGetDouble(io,'input.phase(one).number(step1).current');

% get max drain voltage
maxdrainvoltage = rpLibGetString(io,'input.phase(one).number(maxdrainvoltage).current');
maxdrainvoltage = rpUnitsConvertDbl(maxdrainvoltage,'V');
% get min gate voltage 
mindrainvoltage = rpLibGetString(io,'input.phase(one).number(mindrainvoltage).current');
mindrainvoltage = rpUnitsConvertDbl(mindrainvoltage,'V');
% get step size
 step2 = rpLibGetDouble(io,'input.phase(one).number(step2).current');
% get the loader name
loader = rpLibGetString(io,'input.phase(one).loader.file');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Add your code here for the main body of your program
% --- Executes on button press in simulate_pb.

% hObject    handle to simulate_pb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%axes(handles.simulationplot) set the axes for plotting
%cla % clear the previous plotting
%legend off
m = strcmp(loader,'explore_bigpicture.xml');
if m == 1
  bigpicture(maxgatevoltage,mingatevoltage,maxdrainvoltage,mindrainvoltage,step1,step2,io);
else
  general(gatelength,oxidethickness,gatedielectric,substrate,gatevoltage,io);
end  



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% spit out progress messages as you go along...
rpUtilsProgress(0, 'Starting...');
rpUtilsProgress(5, 'Loading data...');
rpUtilsProgress(50, 'Half-way there');
rpUtilsProgress(100, 'Done');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Save output values back to Rappture
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% save output value for output.curve(simplot)
% this assumes a vector 'x' and a vector 'y'









rpLibResult(io);
quit;
